#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <time.h>
#include "vzioctl.h"
           
static int viz_set_reg(int vzfd, int reg, int value)
{
  int d[3];
  int result;
 
  d[0] = 0x65;
  d[1] = reg;
  d[2] = value;
  result = ioctl(vzfd, VZIOC_SET_REG, d);
  if (result < 0)
    error("Cannot do set reg ioctl (%d)\n", result);

  return result;
}


static int viz_get_reg(int vzfd, int reg, int *value)
{
  int d[3];
  int result;
 
  d[0] = 0x65;
  d[1] = reg;
  d[2] = 0xa5;
  result = ioctl(vzfd, VZIOC_GET_REG, d);
  if (result < 0)
    error("Cannot do set reg ioctl (%d)\n", result);

  if (result == 0)
    (*value) = d[2];

  return result;
}

int xrfd = -1;

int main(int argc, char * argv[]) 
{

	int address=0, value=0;
	int val=0;
	int result=0;
	int i = 0;
	char * device = "/dev/ttyUSB0";
	printf("%s opened succesfully\n", device);

	xrfd = open (device, O_RDWR | O_NOCTTY | O_SYNC);
	if(xrfd < 0) 
	{
		error("error opening %s: %s", device, strerror (errno));
		return 1;
	}

//---- Access register -----//
	if(argc==1)
		printf("Invalid argument\n");
	else
	{	
		address = strtol(argv[1], NULL, 16);
		if(argc==2)
		{	
			result = viz_get_reg(xrfd, address, &val);
			if (result < 0)
			{       
				error("Cannot read from UART: %s\n", strerror(errno));
				return result; 
			}	
			printf("Address[0x%d] = 0x%x \n\n", address, (val & 0xFF));
		}
		else if (argc>=3)
		{
			for(i=2;i<argc;i++)
			{
				value = (int)strtol(argv[i], NULL, 16);
				viz_set_reg(xrfd, address, value);
				address = address + 1;
				usleep(500);
			}
			i=0;
			for(i=0;i<=7;i++)
			{
				result = viz_get_reg(xrfd, i, &val);
				if(result < 0)
				{
					error("Cannot read from UART: %s\n", strerror(errno));
					return result;
				}		
				printf("Address[0x%d]= 0x%x\n", i, (val & 0XFF));
				usleep(500);
			}
		}
	}
    	close(xrfd);
	return 1;
}


